import { OnDestroy, EventEmitter, Renderer2, ElementRef, ChangeDetectorRef, NgZone, TemplateRef, AfterContentInit, QueryList } from '@angular/core';
import { PrimeNGConfig, OverlayService } from 'primeng/api';
import { AnimationEvent } from '@angular/animations';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "primeng/ripple";
import * as i3 from "primeng/api";
export declare class OverlayPanel implements AfterContentInit, OnDestroy {
    el: ElementRef;
    renderer: Renderer2;
    cd: ChangeDetectorRef;
    private zone;
    config: PrimeNGConfig;
    overlayService: OverlayService;
    dismissable: boolean;
    showCloseIcon: boolean;
    style: any;
    styleClass: string;
    appendTo: any;
    autoZIndex: boolean;
    ariaCloseLabel: string;
    baseZIndex: number;
    focusOnShow: boolean;
    mousePosition: boolean;
    showTransitionOptions: string;
    hideTransitionOptions: string;
    onShow: EventEmitter<any>;
    onHide: EventEmitter<any>;
    templates: QueryList<any>;
    container: HTMLDivElement;
    overlayVisible: boolean;
    render: boolean;
    selfClick: boolean;
    documentClickListener: any;
    target: any;
    mouseEvent: any;
    willHide: boolean;
    scrollHandler: any;
    documentResizeListener: any;
    contentTemplate: TemplateRef<any>;
    destroyCallback: Function;
    overlayEventListener: any;
    overlaySubscription: Subscription;
    constructor(el: ElementRef, renderer: Renderer2, cd: ChangeDetectorRef, zone: NgZone, config: PrimeNGConfig, overlayService: OverlayService);
    ngAfterContentInit(): void;
    bindDocumentClickListener(): void;
    unbindDocumentClickListener(): void;
    toggle(event: any, target?: any): void;
    show(event: any, target?: any): void;
    onOverlayClick(event: any): void;
    onContentClick(): void;
    hasTargetChanged(event: any, target: any): boolean;
    appendContainer(): void;
    restoreAppend(): void;
    align(): void;
    private cursorPosition;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationEnd(event: AnimationEvent): void;
    focus(): void;
    hide(): void;
    onCloseClick(event: any): void;
    onWindowResize(event: any): void;
    bindDocumentResizeListener(): void;
    unbindDocumentResizeListener(): void;
    bindScrollListener(): void;
    unbindScrollListener(): void;
    onContainerDestroy(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<OverlayPanel, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OverlayPanel, "p-overlayPanel", never, { "dismissable": { "alias": "dismissable"; "required": false; }; "showCloseIcon": { "alias": "showCloseIcon"; "required": false; }; "style": { "alias": "style"; "required": false; }; "styleClass": { "alias": "styleClass"; "required": false; }; "appendTo": { "alias": "appendTo"; "required": false; }; "autoZIndex": { "alias": "autoZIndex"; "required": false; }; "ariaCloseLabel": { "alias": "ariaCloseLabel"; "required": false; }; "baseZIndex": { "alias": "baseZIndex"; "required": false; }; "focusOnShow": { "alias": "focusOnShow"; "required": false; }; "mousePosition": { "alias": "mousePosition"; "required": false; }; "showTransitionOptions": { "alias": "showTransitionOptions"; "required": false; }; "hideTransitionOptions": { "alias": "hideTransitionOptions"; "required": false; }; }, { "onShow": "onShow"; "onHide": "onHide"; }, ["templates"], ["*"], false, never>;
}
export declare class OverlayPanelModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<OverlayPanelModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<OverlayPanelModule, [typeof OverlayPanel], [typeof i1.CommonModule, typeof i2.RippleModule, typeof i3.SharedModule], [typeof OverlayPanel, typeof i3.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<OverlayPanelModule>;
}
